Index: doc/src/sgml/ref/drop_view.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/drop_view.sgml,v
retrieving revision 1.14
diff -c -r1.14 drop_view.sgml
*** doc/src/sgml/ref/drop_view.sgml	2002/05/18 15:44:47	1.14
--- doc/src/sgml/ref/drop_view.sgml	2002/06/15 16:37:51
***************
*** 21,27 ****
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP VIEW <replaceable class="PARAMETER">name</replaceable> [, ...]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPVIEW-1">
--- 21,27 ----
     <date>1999-07-20</date>
    </refsynopsisdivinfo>
    <synopsis>
! DROP VIEW <replaceable class="PARAMETER">name</replaceable> [, ...] [ CASCADE | RESTRICT ]
    </synopsis>
    
    <refsect2 id="R2-SQL-DROPVIEW-1">
***************
*** 43,48 ****
--- 43,70 ----
        </listitem>
       </varlistentry>
      </variablelist>
+      <variablelist>
+       <varlistentry>
+        <term>RESTRICT</term>
+        <listitem>
+ 	<para>
+ 	 Ensures that only a view with no dependent views or
+ 	 integrity constraints can be destroyed.
+ 	</para>
+        </listitem>
+       </varlistentry>
+       <varlistentry>
+        <term>CASCADE</term>
+        <listitem>
+ 	<para>
+ 	 Any referencing views and integrity constraints
+ 	 will be dropped as well.
+ 	</para>
+        </listitem>
+       </varlistentry>
+      </variablelist>
+     </variablelist>
+ 
     </para>
    </refsect2>
  
***************
*** 133,178 ****
     <title>
      SQL92
     </title>
!    <para>
!     <acronym>SQL92</acronym> specifies some additional capabilities for
!     <command>DROP VIEW</command>:
!    
!     <synopsis>
! DROP VIEW <replaceable class="parameter">view</replaceable> { RESTRICT | CASCADE }
!     </synopsis>
!    </para>
! 
!    <refsect3 id="R3-SQL-DROPVIEW-1">
!     <refsect3info>
!      <date>1998-09-22</date>
!     </refsect3info>
!     <title>
!      Inputs
!     </title>
!     <para>
!      <variablelist>
!       <varlistentry>
!        <term>RESTRICT</term>
!        <listitem>
! 	<para>
! 	 Ensures that only a view with no dependent views or
! 	 integrity constraints can be destroyed.
! 	</para>
!        </listitem>
!       </varlistentry>
!       <varlistentry>
!        <term>CASCADE</term>
!        <listitem>
! 	<para>
! 	 Any referencing views and integrity constraints
! 	 will be dropped as well.
! 	</para>
!        </listitem>
!       </varlistentry>
!      </variablelist>
!     </para>
!    </refsect3>
! 
    <refsect3 id="R3-SQL-DROPVIEW-2">
     <refsect3info>
      <date>1998-09-22</date>
--- 155,161 ----
     <title>
      SQL92
     </title>
!  
    <refsect3 id="R3-SQL-DROPVIEW-2">
     <refsect3info>
      <date>1998-09-22</date>
Index: src/backend/catalog/Makefile
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/Makefile,v
retrieving revision 1.39
diff -c -r1.39 Makefile
*** src/backend/catalog/Makefile	2002/03/26 19:15:22	1.39
--- src/backend/catalog/Makefile	2002/06/15 16:37:51
***************
*** 12,18 ****
  
  OBJS = catalog.o heap.o index.o indexing.o namespace.o aclchk.o \
         pg_aggregate.o pg_largeobject.o pg_namespace.o \
!        pg_operator.o pg_proc.o pg_type.o
  
  BKIFILES = postgres.bki postgres.description
  
--- 12,18 ----
  
  OBJS = catalog.o heap.o index.o indexing.o namespace.o aclchk.o \
         pg_aggregate.o pg_largeobject.o pg_namespace.o \
!        pg_operator.o pg_proc.o pg_type.o pg_depend.o pg_constraint.o
  
  BKIFILES = postgres.bki postgres.description
  
***************
*** 26,33 ****
  # indexing.h had better be last.
  
  POSTGRES_BKI_SRCS := $(addprefix $(top_srcdir)/src/include/catalog/,\
! 	pg_proc.h pg_type.h pg_attribute.h pg_class.h \
! 	pg_attrdef.h pg_relcheck.h pg_inherits.h pg_index.h \
  	pg_operator.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
  	pg_language.h pg_largeobject.h pg_aggregate.h pg_statistic.h \
  	pg_rewrite.h pg_trigger.h pg_listener.h pg_description.h \
--- 26,33 ----
  # indexing.h had better be last.
  
  POSTGRES_BKI_SRCS := $(addprefix $(top_srcdir)/src/include/catalog/,\
! 	pg_proc.h pg_type.h pg_attribute.h pg_class.h pg_depend.h \
! 	pg_attrdef.h pg_constraint.h pg_inherits.h pg_index.h \
  	pg_operator.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
  	pg_language.h pg_largeobject.h pg_aggregate.h pg_statistic.h \
  	pg_rewrite.h pg_trigger.h pg_listener.h pg_description.h \
Index: src/backend/catalog/genbki.sh
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/genbki.sh,v
retrieving revision 1.27
diff -c -r1.27 genbki.sh
*** src/backend/catalog/genbki.sh	2002/04/27 21:24:33	1.27
--- src/backend/catalog/genbki.sh	2002/06/15 16:37:51
***************
*** 224,229 ****
--- 224,233 ----
  	comment_level = 0;
  	nextbkioid = ENVIRON["BKIOBJECTID"];
  	oid = 0;
+ 	pin = "";
+ 	pindata[-1] = "";
+ 	pinoid = 0;
+ 	pinwrite = "";
  }
  
  # ----------------
***************
*** 251,256 ****
--- 255,264 ----
  #	stripping off the DATA( and the ) on the end.  However,
  #	if we see "OID = 0" then we should assign an oid from nextbkioid.
  #	Remember any explicit or assigned OID for use by DESCR().
+ #
+ #	If this is a base table with a PIN id recorded, dump the dependency
+ #	information to a depend file which will be appended onto the data
+ #	for the pg_depend table.
  # ----------------
  /^DATA\(/ {
  	data = substr($0, 6, length($0) - 6);
***************
*** 265,270 ****
--- 273,285 ----
  			nextbkioid++;
  			sub("OID *= *0", "OID = " oid, data);
  		}
+ 
+ 		if (pin != "")
+ 		{
+ 			pinoid = pincount;
+ 			pindata[pinoid] = sprintf("insert (%d %d 0 0 0 0 f)", pin, oid);
+ 			pincount++;
+ 		}
  	}
  	print data;
  	next;
***************
*** 285,290 ****
--- 300,306 ----
  #  end any prior catalog data insertions before starting a define index
  # ----
  	if (reln_open == 1) {
+ 		pinwritedata(pinwrite);
  #		print "show";
  		print "close " catalog;
  		reln_open = 0;
***************
*** 299,304 ****
--- 315,321 ----
  #  end any prior catalog data insertions before starting a define unique index
  # ----
  	if (reln_open == 1) {
+ 		pinwritedata(pinwrite);
  #		print "show";
  		print "close " catalog;
  		reln_open = 0;
***************
*** 309,315 ****
  }
  
  /^BUILD_INDICES/	{ print "build indices"; }
! 	
  # ----------------
  #	CATALOG() definitions take some more work.
  # ----------------
--- 326,340 ----
  }
  
  /^BUILD_INDICES/	{ print "build indices"; }
! 
! /^PINTABLE\(/ {
! 	ret = match($0, /[0-9]+/);
! 	pin = substr($0, RSTART, RLENGTH);
! 
! 	pinwrite = "";
! 	next;
! }
! 
  # ----------------
  #	CATALOG() definitions take some more work.
  # ----------------
***************
*** 318,323 ****
--- 343,349 ----
  #  end any prior catalog data insertions before starting a new one..
  # ----
  	if (reln_open == 1) {
+ 		pinwritedata(pinwrite);
  #		print "show";
  		print "close " catalog;
  		reln_open = 0;
***************
*** 339,344 ****
--- 365,378 ----
  		without_oids = "without_oids ";
  	}
  
+ 	if ($0 ~ /BKI_PINWRITE/) {
+ 		pinwrite = "pinwrite";
+ 	} else {
+ 		pinwrite = "";
+ 	}
+ 
+ 	pin = "";
+ 
          i = 1;
  	inside = 1;
          nc++;
***************
*** 402,410 ****
--- 436,456 ----
  
  END {
  	if (reln_open == 1) {
+ 		pinwritedata(pinwrite);
  #		print "show";
  		print "close " catalog;
  		reln_open = 0;
+ 	}
+ }
+ 
+ ##
+ # write out PINd records
+ function pinwritedata(pinwrite)
+ {
+ 	if (pinwrite == "pinwrite") {
+ 		for (i=0; i < pincount; i++) {
+ 			print pindata[i];
+ 		}
  	}
  }
  ' "descriptionfile=${OUTPUT_PREFIX}.description.$$" > $TMPFILE || exit
